
--<< ================================================= >>--
--     Upvalues                                          --
--<< ================================================= >>--

local _G = _G

local ActionStatus = _G.ActionStatus
local CreateFrame = _G.CreateFrame
local GetCVar = _G.GetCVar
local SetCVar = _G.SetCVar
local UnitBuff = _G.UnitBuff

local pairs = _G.pairs


--<< ================================================= >>--
--     Local Variables                                   --
--<< ================================================= >>--

local isTakingSelfie = false
local cVars = {}


--<< ================================================= >>--
--     The Fuel that Drives the Engine                   --
--<< ================================================= >>--

local PimpMySelfie = CreateFrame("Frame")

function PimpMySelfie:PLAYER_LOGIN()
	self:UnregisterAllEvents()

	-- player name
	cVars["UnitNameOwn"] = GetCVar("UnitNameOwn")

	-- npc names
	cVars["UnitNameFriendlySpecialNPCName"] = GetCVar("UnitNameFriendlySpecialNPCName")
	cVars["UnitNameHostileNPC"] = GetCVar("UnitNameHostileNPC")
	cVars["UnitNameNPC"] = GetCVar("UnitNameNPC")
	cVars["UnitNameNonCombatCreatureName"] = GetCVar("UnitNameNonCombatCreatureName")

	-- friendly players
	cVars["UnitNameFriendlyPlayerName"] = GetCVar("UnitNameFriendlyPlayerName")
	cVars["UnitNameFriendlyPetName"] = GetCVar("UnitNameFriendlyPetName")
	cVars["UnitNameFriendlyGuardianName"] = GetCVar("UnitNameFriendlyGuardianName")
	cVars["UnitNameFriendlyTotemName"] = GetCVar("UnitNameFriendlyTotemName")

	-- enemy players
	cVars["UnitNameEnemyPlayerName"] = GetCVar("UnitNameEnemyPlayerName")
	cVars["UnitNameEnemyPetName"] = GetCVar("UnitNameEnemyPetName")
	cVars["UnitNameEnemyGuardianName"] = GetCVar("UnitNameEnemyGuardianName")
	cVars["UnitNameEnemyTotemName"] = GetCVar("UnitNameEnemyTotemName")

	-- nameplates
	cVars["nameplateShowFriends"] = GetCVar("nameplateShowFriends")
	cVars["nameplateShowEnemies"] = GetCVar("nameplateShowEnemies")

	self:RegisterEvent("UPDATE_OVERRIDE_ACTIONBAR")
end


PimpMySelfie:RegisterEvent("PLAYER_LOGIN")
PimpMySelfie:SetScript("OnEvent", function(self, event, ...) if self[event] then self[event](self, event, ...) end end)
PimpMySelfie:Hide()


--<< ================================================= >>--
--     The Part Where the Magic Happens                  --
--<< ================================================= >>--

function PimpMySelfie:UPDATE_OVERRIDE_ACTIONBAR()
--	isTakingSelfie = UnitBuff("player", "S.E.L.F.I.E. Camera")

	local i = 1
	local _, name, spellID

	-- there is probably a better way to do this
	while true do
		name, _, _, _, _, _, _, _, _, _, spellID = UnitBuff("player", i)

		if not name then
			isTakingSelfie = false
			break
		end

		if spellID == 181765 or spellID == 181884 then
			isTakingSelfie = true
			break
		end

		i = i + 1
	end

	if isTakingSelfie then
		-- hide "screenshot taken" text
		ActionStatus:UnregisterEvent("SCREENSHOT_SUCCEEDED")
		ActionStatus:UnregisterEvent("SCREENSHOT_FAILED")

		-- hide names and nameplates
		for cVar, _ in pairs(cVars) do
			cVars[cVar] = GetCVar(cVar)
			SetCVar(cVar, 0)
		end
	else
		ActionStatus:RegisterEvent("SCREENSHOT_SUCCEEDED")
		ActionStatus:RegisterEvent("SCREENSHOT_FAILED")

		for cVar, value in pairs(cVars) do
			SetCVar(cVar, cVars[cVar])
		end
	end
end
